stages:
  - "build"
  - "deploy"
variables:
  IMAGE_TAGGED: "$CI_REGISTRY_IMAGE/$CONTAINER_NAME:$CI_COMMIT_SHORT_SHA"
  IMAGE_LATEST: "$CI_REGISTRY_IMAGE/$CONTAINER_NAME:latest"
  DOCKER_DRIVER: overlay2
  DOCKER_TLS_CERTDIR: ""

.build-image-kaniko:
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  script:
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"${CI_REGISTRY}\":{\"auth\":\"$(printf "%s:%s" "${CI_REGISTRY_USER}" "${CI_REGISTRY_PASSWORD}" | base64 | tr -d '\n')\"}}}" > /kaniko/.docker/config.json
    - /kaniko/executor --context "${CI_PROJECT_DIR}/$CONTAINER_NAME" --dockerfile "Dockerfile" --destination "$IMAGE_TAGGED" --destination "$IMAGE_LATEST"

build_php:
  stage: build
  extends: .build-image-kaniko
  variables:
    CONTAINER_NAME: "app"
  rules:
    - if: '$CI_PIPELINE_SOURCE == "commit"'
      changes:
        - Dockerfile
      when: always
    - if: $CI_COMMIT_BRANCH == "master"
      when: on_success

deploy:
  stage: deploy
  variables:
    GIT_STRATEGY: clone
  script:
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN $CI_REGISTRY
    - docker-compose -f docker-compose.yml down || true
    - docker-compose -f docker-compose.yml pull
    - docker-compose -f docker-compose.yml up -d
    - docker exec travellist-app composer install
    - docker exec travellist-app php artisan key:generate

  tags:
    - ce
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
      when: on_success
